/*
 *	Sherlock Library -- Search Engine Database Canonical Word Ordering
 *
 *	(c) 1997 Martin Mares, <mj@atrey.karlin.mff.cuni.cz>
 */

#include <charset/unicode.h>

extern inline void
extract_sig(byte *src, byte *dest)
{
  uns cnt = 8;

  while (cnt && *src)
    {
      uns c;
      GET_UTF8(src, c);
      *dest++ = Usig(c);
      cnt--;
    }
  while (cnt)
    {
      *dest++ = 0;
      cnt--;
    }
}

#if 0		/* Not needed anymore, it seems */

extern inline void
extract_sig_uni(word *src, byte *dest)
{
  uns cnt = 8;

  while (cnt && *src)
    {
      uns c = *src++;
      *dest++ = Usig(c);
      cnt--;
    }
  while (cnt)
    {
      *dest++ = 0;
      cnt--;
    }
}

#endif

extern inline int
search_wordcmp(byte *x, byte *y)
{
  byte buf1[8], buf2[8];
  int res;

  extract_sig(x, buf1);
  extract_sig(y, buf2);
  res = memcmp(buf1, buf2, 8);
  return res ? res : strcmp(x, y);
}
